blob: d1c5bb23607dd9bfd382489c4003f5d1a86c85a7 [file] [log] [blame]
jeffhao5d1ac922011-09-29 17:41:15 -07001#!/bin/bash
2#
3# Copyright (C) 2007 The Android Open Source Project
4#
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8#
9# http://www.apache.org/licenses/LICENSE-2.0
10#
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
17# Set up prog to be the path of this script, including following symlinks,
18# and set up progdir to be the fully-qualified pathname of its directory.
19prog="$0"
20while [ -h "${prog}" ]; do
21 newProg=`/bin/ls -ld "${prog}"`
22 newProg=`expr "${newProg}" : ".* -> \(.*\)$"`
23 if expr "x${newProg}" : 'x/' >/dev/null; then
24 prog="${newProg}"
25 else
26 progdir=`dirname "${prog}"`
27 prog="${progdir}/${newProg}"
28 fi
29done
30oldwd=`pwd`
31progdir=`dirname "${prog}"`
32cd "${progdir}"
33progdir=`pwd`
34prog="${progdir}"/`basename "${prog}"`
Brian Carlstrom105215d2012-06-14 12:50:44 -070035test_dir="test-$$"
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +070036tmp_dir="/tmp/$USER/${test_dir}"
jeffhao5d1ac922011-09-29 17:41:15 -070037
38export JAVA="java"
Brian Carlstrom5103ce62014-03-30 16:17:42 -070039export JAVAC="javac -g"
jeffhao5d1ac922011-09-29 17:41:15 -070040export RUN="${progdir}/etc/push-and-run-test-jar"
Brian Carlstrom105215d2012-06-14 12:50:44 -070041export DEX_LOCATION=/data/run-test/${test_dir}
Elliott Hughesc717eef2012-06-15 16:01:26 -070042export NEED_DEX="true"
jeffhao5d1ac922011-09-29 17:41:15 -070043
Tsu Chiang Chuang4407e612012-07-19 16:13:43 -070044# If dx was not set by the environment variable, assume it is in the path.
45if [ -z "$DX" ]; then
46 export DX="dx"
47fi
48
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080049# If jasmin was not set by the environment variable, assume it is in the path.
50if [ -z "$JASMIN" ]; then
51 export JASMIN="jasmin"
52fi
53
54
jeffhao5d1ac922011-09-29 17:41:15 -070055info="info.txt"
56build="build"
57run="run"
58expected="expected.txt"
59output="output.txt"
60build_output="build-output.txt"
Brian Carlstromdc959ea2013-10-28 00:44:49 -070061lib="libartd.so"
jeffhao5d1ac922011-09-29 17:41:15 -070062run_args="--quiet"
63
Brian Carlstrom2613de42012-06-15 17:37:16 -070064target_mode="yes"
jeffhao5d1ac922011-09-29 17:41:15 -070065dev_mode="no"
66update_mode="no"
67debug_mode="no"
Jeff Hao201803f2013-11-20 18:11:39 -080068runtime="art"
jeffhao5d1ac922011-09-29 17:41:15 -070069usage="no"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -070070build_only="no"
Andreas Gampe2fe07922014-04-21 07:50:39 -070071suffix64=""
jeffhao5d1ac922011-09-29 17:41:15 -070072
73while true; do
74 if [ "x$1" = "x--host" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -070075 target_mode="no"
jeffhao5d1ac922011-09-29 17:41:15 -070076 RUN="${progdir}/etc/host-run-test-jar"
TDYa127b92bcab2012-04-08 00:09:51 -070077 DEX_LOCATION=$tmp_dir
jeffhao5d1ac922011-09-29 17:41:15 -070078 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -080079 elif [ "x$1" = "x--jvm" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -070080 target_mode="no"
Jeff Hao201803f2013-11-20 18:11:39 -080081 runtime="jvm"
jeffhao5d1ac922011-09-29 17:41:15 -070082 RUN="${progdir}/etc/reference-run-test-classes"
Elliott Hughesc717eef2012-06-15 16:01:26 -070083 NEED_DEX="false"
jeffhao5d1ac922011-09-29 17:41:15 -070084 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -080085 elif [ "x$1" = "x-O" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -070086 lib="libart.so"
87 shift
88 elif [ "x$1" = "x--dalvik" ]; then
89 lib="libdvm.so"
Jeff Hao201803f2013-11-20 18:11:39 -080090 runtime="dalvik"
Brian Carlstromdc959ea2013-10-28 00:44:49 -070091 shift
92 elif [ "x$1" = "x--image" ]; then
93 shift
94 image="$1"
95 run_args="${run_args} --image $image"
Elliott Hughes7c046102011-10-19 18:16:03 -070096 shift
Nicolas Geoffray92cf83e2014-03-18 17:59:20 +000097 elif [ "x$1" = "x-Xcompiler-option" ]; then
98 shift
99 option="$1"
100 run_args="${run_args} -Xcompiler-option $option"
101 shift
Mathieu Chartier769a5ad2014-05-18 15:30:10 -0700102 elif [ "x$1" = "x--runtime-option" ]; then
103 shift
104 option="$1"
105 run_args="${run_args} --runtime-option $option"
106 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700107 elif [ "x$1" = "x--debug" ]; then
108 run_args="${run_args} --debug"
109 shift
110 elif [ "x$1" = "x--gdb" ]; then
111 run_args="${run_args} --gdb"
112 dev_mode="yes"
113 shift
114 elif [ "x$1" = "x--zygote" ]; then
115 run_args="${run_args} --zygote"
116 shift
jeffhao0dff3f42012-11-20 15:13:43 -0800117 elif [ "x$1" = "x--interpreter" ]; then
118 run_args="${run_args} --interpreter"
119 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700120 elif [ "x$1" = "x--no-verify" ]; then
121 run_args="${run_args} --no-verify"
122 shift
123 elif [ "x$1" = "x--no-optimize" ]; then
124 run_args="${run_args} --no-optimize"
125 shift
126 elif [ "x$1" = "x--no-precise" ]; then
127 run_args="${run_args} --no-precise"
128 shift
Elliott Hughes7c046102011-10-19 18:16:03 -0700129 elif [ "x$1" = "x--invoke-with" ]; then
130 shift
131 what="$1"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700132 if [ "x$what" = "x" ]; then
133 echo "$0 missing argument to --invoke-with" 1>&2
134 usage="yes"
135 break
136 fi
Ian Rogers0e033672013-04-19 10:22:46 -0700137 run_args="${run_args} --invoke-with ${what}"
jeffhao5d1ac922011-09-29 17:41:15 -0700138 shift
139 elif [ "x$1" = "x--dev" ]; then
140 run_args="${run_args} --dev"
141 dev_mode="yes"
142 shift
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700143 elif [ "x$1" = "x--build-only" ]; then
144 build_only="yes"
145 shift
146 elif [ "x$1" = "x--output-path" ]; then
147 shift
148 tmp_dir=$1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700149 if [ "x$tmp_dir" = "x" ]; then
150 echo "$0 missing argument to --output-path" 1>&2
151 usage="yes"
152 break
153 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700154 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700155 elif [ "x$1" = "x--update" ]; then
156 update_mode="yes"
157 shift
158 elif [ "x$1" = "x--help" ]; then
159 usage="yes"
160 shift
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700161 elif [ "x$1" = "x--64" ]; then
162 run_args="${run_args} --64"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700163 suffix64="64"
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700164 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700165 elif expr "x$1" : "x--" >/dev/null 2>&1; then
Elliott Hughes7c046102011-10-19 18:16:03 -0700166 echo "unknown $0 option: $1" 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700167 usage="yes"
168 break
169 else
170 break
171 fi
172done
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +0700173mkdir -p $tmp_dir
jeffhao5d1ac922011-09-29 17:41:15 -0700174
Jeff Hao201803f2013-11-20 18:11:39 -0800175if [ ! "$runtime" = "jvm" ]; then
176 run_args="${run_args} --lib $lib"
177fi
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700178
Jeff Hao201803f2013-11-20 18:11:39 -0800179if [ "$runtime" = "dalvik" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700180 if [ "$target_mode" = "no" ]; then
181 framework="${OUT}/system/framework"
182 bpath="${framework}/core.jar:${framework}/conscrypt.jar:${framework}/okhttp.jar:${framework}/core-junit.jar:${framework}/bouncycastle.jar:${framework}/ext.jar"
183 run_args="${run_args} --boot -Xbootclasspath:${bpath}"
184 else
185 true # defaults to using target BOOTCLASSPATH
186 fi
Jeff Hao201803f2013-11-20 18:11:39 -0800187elif [ "$runtime" = "art" ]; then
188 if [ "$target_mode" = "no" ]; then
Brian Carlstrom43534862014-02-19 01:13:52 -0800189 # ANDROID_BUILD_TOP and ANDROID_HOST_OUT are not set in a build environment.
190 if [ -z "$ANDROID_BUILD_TOP" ]; then
191 export ANDROID_BUILD_TOP=$oldwd
192 fi
193 if [ -z "$ANDROID_HOST_OUT" ]; then
194 export ANDROID_HOST_OUT=$ANDROID_BUILD_TOP/out/host/linux-x86
195 fi
Jeff Hao201803f2013-11-20 18:11:39 -0800196 run_args="${run_args} --boot -Ximage:${ANDROID_HOST_OUT}/framework/core.art"
197 else
Brian Carlstrom0e12bdc2014-05-14 17:44:28 -0700198 run_args="${run_args} --boot -Ximage:/data/art-test/core.art"
Jeff Hao201803f2013-11-20 18:11:39 -0800199 fi
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700200fi
201
jeffhao5d1ac922011-09-29 17:41:15 -0700202if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then
203 echo "--dev and --update are mutually exclusive" 1>&2
204 usage="yes"
205fi
206
207if [ "$usage" = "no" ]; then
208 if [ "x$1" = "x" -o "x$1" = "x-" ]; then
209 test_dir=`basename "$oldwd"`
210 else
211 test_dir="$1"
212 fi
213
214 if [ '!' -d "$test_dir" ]; then
215 td2=`echo ${test_dir}-*`
216 if [ '!' -d "$td2" ]; then
217 echo "${test_dir}: no such test directory" 1>&2
218 usage="yes"
219 fi
220 test_dir="$td2"
221 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700222 # Shift to get rid of the test name argument. The rest of the arguments
223 # will get passed to the test run.
224 shift
225fi
226
227if [ "$usage" = "yes" ]; then
228 prog=`basename $prog`
229 (
230 echo "usage:"
231 echo " $prog --help Print this message."
232 echo " $prog [options] [test-name] Run test normally."
233 echo " $prog --dev [options] [test-name] Development mode" \
234 "(dumps to stdout)."
235 echo " $prog --update [options] [test-name] Update mode" \
236 "(replaces expected.txt)."
237 echo ' Omitting the test name or specifying "-" will use the' \
238 "current directory."
239 echo " Runtime Options:"
Nicolas Geoffray92cf83e2014-03-18 17:59:20 +0000240 echo " -O Run non-debug rather than debug build (off by default)."
241 echo " -Xcompiler-option Pass an option to the compiler."
Mathieu Chartier769a5ad2014-05-18 15:30:10 -0700242 echo " -runtime-option Pass an option to the runtime."
Nicolas Geoffray92cf83e2014-03-18 17:59:20 +0000243 echo " --debug Wait for a debugger to attach."
244 echo " --gdb Run under gdb; incompatible with some tests."
245 echo " --build-only Build test files only (off by default)."
246 echo " --interpreter Enable interpreter only mode (off by default)."
247 echo " --no-verify Turn off verification (on by default)."
248 echo " --no-optimize Turn off optimization (on by default)."
249 echo " --no-precise Turn off precise GC (on by default)."
250 echo " --zygote Spawn the process from the Zygote." \
jeffhao5d1ac922011-09-29 17:41:15 -0700251 "If used, then the"
Nicolas Geoffray92cf83e2014-03-18 17:59:20 +0000252 echo " other runtime options are ignored."
253 echo " --host Use the host-mode virtual machine."
254 echo " --invoke-with Pass --invoke-with option to runtime."
255 echo " --dalvik Use Dalvik (off by default)."
256 echo " --jvm Use a host-local RI virtual machine."
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700257 echo " --output-path [path] Location where to store the build" \
258 "files."
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700259 echo " --64 Run the test in 64-bit mode"
jeffhao5d1ac922011-09-29 17:41:15 -0700260 ) 1>&2
261 exit 1
262fi
263
264cd "$test_dir"
265test_dir=`pwd`
266
267td_info="${test_dir}/${info}"
268td_expected="${test_dir}/${expected}"
269
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700270if [ ! -r $td_info ]; then
271 echo "${test_dir}: missing file $td_info" 1>&2
272 exit 1
273fi
274
275if [ ! -r $td_expected ]; then
276 echo "${test_dir}: missing file $td_expected" 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700277 exit 1
278fi
279
280# copy the test to a temp dir and run it
281
Elliott Hughes510c8782011-10-06 10:57:34 -0700282echo "${test_dir}: building..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700283
284rm -rf "$tmp_dir"
285cp -Rp "$test_dir" "$tmp_dir"
286cd "$tmp_dir"
287
288if [ '!' -r "$build" ]; then
289 cp "${progdir}/etc/default-build" build
290fi
291
292if [ '!' -r "$run" ]; then
293 cp "${progdir}/etc/default-run" run
294fi
295
296chmod 755 "$build"
297chmod 755 "$run"
298
Elliott Hughes8cbc8bc2011-10-04 11:19:45 -0700299export TEST_NAME=`basename ${test_dir}`
300
Ian Rogers997f0f92014-06-21 22:58:05 -0700301# To cause tests to fail fast, limit the file sizes created by dx, dex2oat and ART output to 2MB.
302file_size_limit=2048
303if echo "$test_dir" | grep 089; then
304 file_size_limit=5120
305elif echo "$test_dir" | grep 083; then
306 file_size_limit=5120
307fi
308if ! ulimit "$file_size_limit"; then
309 echo "ulimit file size setting failed"
310fi
311
jeffhao5d1ac922011-09-29 17:41:15 -0700312good="no"
313if [ "$dev_mode" = "yes" ]; then
314 "./${build}" 2>&1
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700315 build_exit="$?"
316 echo "build exit status: $build_exit" 1>&2
317 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800318 echo "${test_dir}: running..." 1>&2
319 "./${run}" $run_args "$@" 2>&1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700320 run_exit="$?"
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800321 echo "run exit status: $run_exit" 1>&2
322 if [ "$run_exit" = "0" ]; then
323 good="yes"
324 fi
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700325 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700326elif [ "$update_mode" = "yes" ]; then
327 "./${build}" >"$build_output" 2>&1
328 build_exit="$?"
329 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800330 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700331 "./${run}" $run_args "$@" >"$output" 2>&1
332 sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}"
333 good="yes"
334 else
335 cat "$build_output" 1>&2
336 echo "build exit status: $build_exit" 1>&2
337 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700338elif [ "$build_only" = "yes" ]; then
339 good="yes"
340 "./${build}" >"$build_output" 2>&1
341 build_exit="$?"
342 if [ "$build_exit" '!=' '0' ]; then
343 cp "$build_output" "$output"
344 echo "build exit status: $build_exit" >>"$output"
345 diff --strip-trailing-cr -q "$expected" "$output" >/dev/null
346 if [ "$?" '!=' "0" ]; then
347 good="no"
348 echo "BUILD FAILED For ${TEST_NAME}"
349 fi
350 fi
Tsu Chiang Chuang379e2f52013-08-20 12:24:52 -0700351 # Clean up extraneous files that are not used by tests.
Tsu Chiang Chuang0160d992013-09-13 14:17:42 -0700352 find $tmp_dir -mindepth 1 ! -regex ".*/\(.*jar\|$output\|$expected\)" | xargs rm -rf
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700353 exit 0
jeffhao5d1ac922011-09-29 17:41:15 -0700354else
355 "./${build}" >"$build_output" 2>&1
356 build_exit="$?"
357 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800358 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700359 "./${run}" $run_args "$@" >"$output" 2>&1
360 else
361 cp "$build_output" "$output"
362 echo "build exit status: $build_exit" >>"$output"
363 fi
364 diff --strip-trailing-cr -q "$expected" "$output" >/dev/null
365 if [ "$?" = "0" ]; then
366 # output == expected
367 good="yes"
368 echo "${test_dir}: succeeded!" 1>&2
369 fi
370fi
371
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700372# Clean up test files.
373if [ "$good" == "yes" ]; then
jeffhao5d1ac922011-09-29 17:41:15 -0700374 cd "$oldwd"
375 rm -rf "$tmp_dir"
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700376 if [ "$target_mode" = "yes" -a "$build_exit" = "0" ]; then
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +0700377 adb shell rm -rf $DEX_LOCATION
Brian Carlstrom105215d2012-06-14 12:50:44 -0700378 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700379 exit 0
380fi
381
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700382
jeffhao5d1ac922011-09-29 17:41:15 -0700383(
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700384 if [ "$update_mode" != "yes" ]; then
jeffhao5d1ac922011-09-29 17:41:15 -0700385 echo "${test_dir}: FAILED!"
386 echo ' '
387 echo '#################### info'
388 cat "${td_info}" | sed 's/^/# /g'
389 echo '#################### diffs'
Ian Rogers997f0f92014-06-21 22:58:05 -0700390 diff --strip-trailing-cr -u "$expected" "$output" | tail -n 500
jeffhao5d1ac922011-09-29 17:41:15 -0700391 echo '####################'
392 echo ' '
393 fi
Brian Carlstrom105215d2012-06-14 12:50:44 -0700394 echo "${TEST_NAME} files left in ${tmp_dir} on host"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700395 if [ "$target_mode" == "yes" ]; then
Brian Carlstrom105215d2012-06-14 12:50:44 -0700396 echo "and in ${DEX_LOCATION} on target"
397 fi
398
jeffhao5d1ac922011-09-29 17:41:15 -0700399) 1>&2
400
401exit 1